/******************************************************************************
* To the extent possible under law, Sebastian Roith
* <https://www.roith-unterrichtet.de> has waived all copyright and related or
* neighboring rights to this script. This work is published from Germany.
******************************************************************************/

/**
* Daten von formatierbaren Zeichen
*/
function ParagraphDataBuilder() {
    this._attributes = [
        new AttributeSet('ausrichtung', [ { key: 'links', value: 'left' }, { key: 'zentriert', value: 'center' }, { key: 'rechts', value: 'right' }, { key: 'Blocksatz', value: 'justify' } ]),
        new AttributeNumber('zeilenhoehe', 0, 10, 1),
        new AttributeNumber('abstandOben', -100, 100, 0),
        new AttributeNumber('abstandUnten', -100, 100, 0),
        new AttributeNumber('einzugLinks', -100, 100, 0),
        new AttributeNumber('einzugRechts', -100, 100, 0),
        new AttributeNumber('einzugErsteZeile', -100, 100, 0),
        new AttributeColor('hintergrund', true)
    ];
    this._attributes[2].defaultValue = 1.3;
}

// Alle Attribute
ParagraphDataBuilder.prototype._attributes = [];

/**
* Alle Attributnamen ermitteln
* @return Array     Attributnamen als Strings
*/
ParagraphDataBuilder.prototype.getAttributeNames = function() {
    return this._attributes.map(function(item) { return item.attributeName; });
}

/**
* Eingegebene Attributwerte in tatsächliche Attributwerte umwandeln
* @return Object    Objekt mit Attributen message (Fehlermeldung, falls vorhanden) und object (Objekt mit tatsächlichen Attributwerten)
*/
ParagraphDataBuilder.prototype.createFromAtts = function(
    atts        // Eingegebene Attributwerte
) {
    var obj = {};
    var s;
    for (var n = 0; n < this._attributes.length; ++n) {
        if (s = this._attributes[n].readValue(atts[this._attributes[n].attributeName], obj))
            return { message: s, object: obj };
    }
    return { message: '', object: obj };
}
